package com.ejie.ab79.dao.expedientes;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.expedientes.TiposDocumento;

/**
 * TiposDocumentoDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class TiposDocumentoDaoImpl implements TiposDocumentoDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDTIPODOCUMENTO", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	private RowMapper<TiposDocumento> rwMap = new RowMapper<TiposDocumento>() {
		public TiposDocumento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposDocumento(resultSet.getLong("IDTIPODOCUMENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<TiposDocumento> rwMapPK = new RowMapper<TiposDocumento>() {
		public TiposDocumento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposDocumento(resultSet.getLong("IDTIPODOCUMENTO"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public TiposDocumento find(TiposDocumento tiposdocumento) {
		String query = "SELECT t1.ID_TIPO_DOCUMENTO IDTIPODOCUMENTO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM TIPOS_DOCUMENTO t1  WHERE t1.ID_TIPO_DOCUMENTO = ?  ";

		List<TiposDocumento> tiposdocumentoList = this.jdbcTemplate.query(query, this.rwMap,
				tiposdocumento.getIdTipoDocumento());
		return DataAccessUtils.uniqueResult(tiposdocumentoList);
	}

	public TiposDocumento findIdTipoDocumento(String nombreDocumento) {
		String query = "SELECT t1.ID_TIPO_DOCUMENTO IDTIPODOCUMENTO FROM TIPOS_DOCUMENTO t1  WHERE t1.DESCRIPCION_CASTELLANO = ? ";

		List<TiposDocumento> tiposdocumentoList = this.jdbcTemplate.query(query, this.rwMapPK, nombreDocumento);
		return DataAccessUtils.uniqueResult(tiposdocumentoList);

	}

	@Transactional(readOnly = true)
	public List<TiposDocumento> findAll(TiposDocumento tiposdocumento) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_DOCUMENTO IDTIPODOCUMENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM TIPOS_DOCUMENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tiposdocumento);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	private Map<String, ?> getWhereMap(TiposDocumento tiposdocumento) {

		StringBuilder where = new StringBuilder(TiposDocumentoDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tiposdocumento != null && tiposdocumento.getIdTipoDocumento() != null) {
			where.append(" AND t1.ID_TIPO_DOCUMENTO = ?");
			params.add(tiposdocumento.getIdTipoDocumento());
		}
		if (tiposdocumento != null && tiposdocumento.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(tiposdocumento.getDescripcionCastellano());
		}
		if (tiposdocumento != null && tiposdocumento.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(tiposdocumento.getDescripcionEuskera());
		}
		if (tiposdocumento != null && tiposdocumento.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(tiposdocumento.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
